package core

type ISubService interface {
	Prepare(ctx *SubServiceContext) error
	Run(ctx *SubServiceContext) error
	Stop(ctx *SubServiceContext)
}

type SubServiceWrapper struct {
	subSvc ISubService
	name   string
	ctx    *SubServiceContext
}

func NewSubServiceWrapper(frame IAppFramework, name string, svc ISubService) *SubServiceWrapper {
	w := &SubServiceWrapper{
		subSvc: svc,
		name:   name,
		ctx:    NewSubServiceContext(name, frame),
	}
	return w
}

func (w *SubServiceWrapper) Prepare() error {
	return w.subSvc.Prepare(w.ctx)
}

func (w *SubServiceWrapper) Run() error {
	return w.subSvc.Run(w.ctx)
}

func (w *SubServiceWrapper) Stop(xerr error) {
	w.subSvc.Stop(w.ctx)
}
