package core

import "context"

var _ IModuleLogger = (*SubServiceContext)(nil)

type SubServiceContext struct {
	fw IAppFramework
	IModuleLogger
}

func NewSubServiceContext(name string, fw IAppFramework) *SubServiceContext {
	c := &SubServiceContext{
		fw:            fw,
		IModuleLogger: fw.GetModuleLogger(name),
	}
	return c
}

func (c *SubServiceContext) GetParentContext() context.Context {
	return c.fw.GetContext()
}

func (c *SubServiceContext) GetGlobalDebugMode() bool {
	return c.fw.IsGlobalDebugMode()
}
