package easy_toml_config

import (
	"fmt"
	"github.com/pelletier/go-toml/v2"
	"os"
)

func LoadConfigFromFile(filename string, v interface{}) error {
	f, err := os.ReadFile(filename)
	if err != nil {
		return fmt.Errorf("failed read config file '%s': %v", filename, err)
	}
	err = toml.Unmarshal(f, v)
	if err != nil {
		return fmt.Errorf("failed parse config file '%s': %v", filename, err)
	}
	return nil
}
