package websubsvc

import (
	"io/fs"
	"os"
	"path"
)

type IFilesystem interface {
	fs.StatFS
}

var _ IFilesystem = (*OsFsWithPrefix)(nil)

type OsFsWithPrefix struct {
	prefix string
}

func NewOsFsWithPrefix(prefix string) *OsFsWithPrefix {
	f := &OsFsWithPrefix{
		prefix: prefix,
	}
	return f
}

func (o OsFsWithPrefix) Open(name string) (fs.File, error) {
	return os.Open(path.Join(o.prefix, name))
}

func (o OsFsWithPrefix) Stat(name string) (fs.FileInfo, error) {
	return os.Stat(path.Join(o.prefix, name))
}
